# PodProx
## Was tut PodProx
PodProx ermöglicht es allen Clients die BitTorrent-Podcast-Feeds von [bitlove.org](http://bitlove.org) zu nutzen. Dazu muss dieses Tool auf einen Rechner welcher sowieso den ganzen Tag läuft und am Netz hängt laufen. 

PodProx stellt einen Proxy für den bitlove-Feed. Dazu wird der Feed manipuliert, so dass die Podcast-Links auf PodProx zeigen. Wird ein Podcast durch den Manipulierten Feed angefordert lädt PodProx diesen per BitTorrent mit Hilfe von Transmission herunter und liefert ihn an den Podcast-Client aus.

Transmission Seeded die Podcasts dann weiter um das Netzwerk zu unterstützen.

## Was wird benötigt

PodProx sollte auf einem Rechner laufen, welcher immer dann läuft, wenn ihr Podcasts laden wollt. Ein NAS oder Homeserver oder auch ein Computer der rund um die Uhr läuft bietet sich an. Wenn nur auf einem Gerät Podcast gehört wird, reicht es natürlich auch wenn PodProx auf diesem Computer läuft.

Außerdem muss auf dem Gerät Python und Transmission laufen. Dies dürfte kein Problem darstellen, da diese Tools auf ziemlich jedem Betriebssystem laufen. (Außer natürlich auf Smartphone-Betriebssystemen)

Außerdem sollte in Transmission das Webinterface (jedenfalls für 127.0.0.1) aktiviert sein.

## Installation

* Das Tool (es reicht der Inhalt des src Ordners) auf den Computer auf dem es laufen soll kopieren

* Ein Verzeichnis erstellen in dem Die Podcasts gespeichert werden sollen (muss nicht im PodProx Verzeichnis liegen)

* Die `config.cfg.example` zu `config.cfg` umbenennen und folgende Werte anpassen:

 * Der Wert hinter `HOST_NAME:` sollte die IP-Adresse des Computers sein auf dem PodProx läuft
 * Der Wert hinter `PORT_NUMBER=` ist der Port auf dem PodProx läuft.
 * Der Wert hinter `EXTERN_HOST_NAME:` ist die DynDNS-Adresse. Dies ist nur Relevant, wenn von Außerhalb auf die PodProx installation zugegriffen werden soll. Dies ist aber mit Vorsicht zu genießen, da PodProx (noch) keinen Passwortschutz besitzt und nicht gegen Angriffe geschützt ist. Hier sollte im Normalfall einfach die gleiche IP stehen wie hinter `HOST_NAME:`
 * Der Wert hinter `EXTERN_PORT_NUMBER:` ist der Externe Port. Im Normalfall sollte hier das gleiche wie hinter `PORT_NUMBER=` stehen.
 * Der Wert hinter `DOCROOT:` ist das Verzeichnis in dem Die Podcast-Dateien abgelegt werden. Wichtig ist, dass der abschließende `/` **fehlt**. PodProx und Transmission brauchen lese und schreibzugriff für dieses Verzeichnis

## Benutzung

PodProx wird über die Komandozeile gestartet. Dazu muss im PodProx-Programmverzeichnis `python server.py` ausgeführt werden. Außerdem muss Transmission laufen.
 
Die Abfrage des jeweiligen Podcasts aus dem Podfetcher geht dann so:

    http://localhost:9000/http://bitlove.org/podcaster/podcast/feed
    
Hierbei muss `localhost` und die Zahl durch die Jeweilige IP und den Port ersetzt werden. hinter dem `/` folgt die Feed-Adresse.

## Weiterentwicklung

Schau bitte in den [Bugtracker auf Bitbucket](https://bitbucket.org/ubahnverleih/podprox/issues), dort stehen bekannte Probleme und Diskussionen, was aktuell noch an der Software auszusetzen ist und welche Probleme gelöst werden können. Möchtest du auch an der Software arbeiten und deine Arbeit wieder hier einfließen lassen, halte bitte kurz Rücksprache, damit wir am gleichen Strang ziehen.

PodProx Basiert auf [Feedreconstructor](https://bitbucket.org/faldrian/feedreconstructor) von Faldrian. Vielen Dank für die Tolle vorarbeit

In Zukunft plane ich ein Paket für Synology DSM damit die Installation auf diesen Geräten vereinfacht wird.
