#!/usr/bin/env python
# -*- coding: utf8 -*-

import os
import ConfigParser

class BitloveUrlParser:
	def __init__(self,inURL):
		self.url = inURL
		self.podcaster = self.url.split("bitlove.org/",1)[1].split("/")[0]
		self.podcast = self.url.split("bitlove.org/",1)[1].split("/")[1]

		config = ConfigParser.ConfigParser()
		config.read(os.path.dirname(os.path.abspath(__file__)) + "/config.cfg")
		self.DOCROOT = config.get("Konfiguration", "DOCROOT")
	
	def getPath(self):
		if (os.path.exists(self.DOCROOT+"/"+self.podcaster)):
			if (not os.path.exists(self.DOCROOT+"/"+self.podcaster+"/"+self.podcast)):
				#Pfad gibts schon
				#else:
				os.mkdir(self.DOCROOT+"/"+self.podcaster+"/"+self.podcast)
		else:
			os.mkdir(self.DOCROOT+"/"+self.podcaster)
			os.mkdir(self.DOCROOT+"/"+self.podcaster+"/"+self.podcast)
		return ("/"+self.podcaster+"/"+self.podcast)
